{% extends "layouts/base.html" %}

{% block title %}
	{{ title }}
{% endblock %}

{% block content %}
	<div class="container">
        <a class="btn btn btn-outline-secondary mb-2" href="/">←</a>
		<h3>
			Find Group Users
		</h3>
		{% if groups %}
			<form method="post">
				<div class="row g-0 align-items-center">
                    <div class="col-1">
                        <label>Select Group:</label>
                    </div>
                    <div class="col">
                        <input class="form-control" name="groupname" list="groupLists" id="" placeholder="Type to search...">
                    </div>
					<datalist id="groupLists">
						{% for group in groups %}
                            <option value="{{group.group_name}}"></option>
						{% endfor %}
					</datalist>
					<button class="col-2 btn btn-secondary" id="add-group" type="button">Add Group</button>
				</div>
				<br>
                <hr class="my-2">
				<div class="row">
                    <div class="col">
                        <label>Selected Groups:</label> 
                        <button id="clear-selections" class="ms-1 py-0 btn btn-sm btn-danger" type="button">Clear Selection</button>
                        <button id="submit-groups" class="ms-1 py-0 btn btn-sm btn-primary" type="button" disabled="disabled">Get group users</button>
                    </div>
					<div name='selected-groups' id='selected-groups' class="m-2 d-flex flex-row"></div>
				</div>
				<div class="loader"></div>
			</form>
            <div id="data-container"></div>
		{% else %}
			Sorry, the group doesn't exist!
		{% endif %}
	</div>
{% endblock %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}
	<script>
    let selectedGroupNames = []

    // Able to select multiple groups to export!
    $("#add-group").click(function(event) {
        let selectedGroupName = $("input[name=groupname]").val()
        if (selectedGroupName === "") {
            alert("You didn't pick any group yet!")
        }
        else if (selectedGroupNames.includes(selectedGroupName)) {
            alert(selectedGroupName + ' is already selected!')
            $("input[name=groupname]").val("")
        }
        else {
            selectedGroupNames.push(selectedGroupName)
            $("#submit-groups").removeAttr("disabled")
            $('#selected-groups').append("<div class='px-3 py-2 btn btn-outline-dark'>"+selectedGroupName+"</div>")
            $("input[name=groupname]").val("")
        }
    });

    $("#clear-selections").click(function(event) {
        selectedGroupNames.length = 0;
        $('#selected-groups').empty();
        $("#submit-groups").attr("disabled","disabled")
        $("#data-container").empty();
    });

    $("#submit-groups").click(function(event) {
        $(".loader").show()
        $("#submit").hide()
        $.ajax({
            type: "POST",
            url: "{{ url_for('group_users_blueprint.api_list_group_users') }}",
            data: JSON.stringify({
                "groups": selectedGroupNames
            }),
            processData: false,
            contentType: 'application/json',
            success: function(response) {
                $('#data-container').html(response.html);

                $("#download-group-users").click(function(event) {
                    $.ajax({
                        type: "POST",
                        url: "{{ url_for('group_users_blueprint.api_download_group_users') }}",
                        data: JSON.stringify({
                            "data": response.data,
                            "headers": response.flex_table_headers
                        }),
                        processData: false,
                        contentType: 'application/json',
                        xhrFields: {
                            responseType: 'arraybuffer'
                        },
                        success: function(response) {
                            var blob = new Blob([response], {type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'});
                            var link = document.createElement('a');
                            link.href = window.URL.createObjectURL(blob);
                            link.download = 'data.xlsx';
                            link.click();
                        },
                        error: function() {
                            alert("SOMETHING WRONG!")
                        }
                    })
                })
            },
            error: function() {
                alert("SOMETHING WRONG!")
            }
        })

    });


    
    </script>
{% endblock javascripts %}
